package com.shadeslider.base 
{
    import flash.events.*;
    
    public class AbstractModel extends flash.events.EventDispatcher
    {
        public function AbstractModel(arg1:Object=null, arg2:Object=null)
        {
            super();
            this.config = arg2;
            this.mainModel = arg1;
            this._children = new Object();
            this.addChildren();
            this.initDefaultState();
            return;
        }

        public function getChild(arg1:String):com.shadeslider.base.AbstractModel
        {
            return this._children[arg1];
        }

        protected function initDefaultState():void
        {
            return;
        }

        public function modelState():void
        {
            dispatchEvent(new com.shadeslider.base.ModelEvent(com.shadeslider.base.ModelEvent.STATE));
            return;
        }

        public function update():void
        {
            dispatchEvent(new com.shadeslider.base.ModelEvent(com.shadeslider.base.ModelEvent.UPDATE));
            return;
        }

        protected function addChildren():void
        {
            return;
        }

        public function addChild(arg1:String, arg2:com.shadeslider.base.AbstractModel):void
        {
            this._children[arg1] = arg2;
            return;
        }

        public function get children():Object
        {
            return this._children;
        }

        protected var config:Object;

        protected var mainModel:Object;

        protected var _children:Object;
    }
}
